import { HubConnection } from "@microsoft/signalr";
/**
 * Invokes a hub method on the server and provide the async state (loading & error)
 * @param hubConnection The hub connection to use
 * @param methodName The name of the server method to invoke.
 */
export declare function useHubCallback<T>(hubConnection: HubConnection, methodName: string): {
    loading: boolean;
    data?: T | undefined;
    error?: any;
    invoke: (...args: any[]) => Promise<T | undefined>;
};
