import { HubConnection } from "@microsoft/signalr";
/**
 * Provide an "invoke" function to invokes a hub method on the server and provide the async state (loading & error)
 * @param hubConnection The hub connection to use
 * @param methodName The name of the server method to invoke.
 */
export declare function useHubSender<T>(hubConnection: HubConnection | undefined, methodName: string): {
    loading: boolean;
    data?: T | undefined;
    error?: any;
    invoke: (...args: any[]) => Promise<T | undefined>;
};
