import { HubConnection, HubConnectionState } from "@microsoft/signalr";
/**
 * Start/Stop the provided hub connection (on connection change or when the component is unmounted)
 * @param {HubConnection} hubConnection The signalR hub connection
 * @return {HubConnection} the current signalr connection
 * @return {any} the signalR error in case the start does not work
 */
export declare function useSignalR(hubConnection?: HubConnection): {
    hubConnectionState: HubConnectionState;
    error: undefined;
};
